#libraries
library(dispRity)

#data_independent
read.csv2("node_ages_ind-compar.csv")->data_ind

data_ind$mean<-as.numeric(data_ind$mean)
data_ind$lower<-as.numeric(data_ind$lower)
data_ind$upper<-as.numeric(data_ind$upper)
data_ind$max.min<-as.numeric(data_ind$max.min)

#sep_dataset
d_20_ind<-data_ind[data_ind$tree=="20k",]
d_50_ind<-data_ind[data_ind$tree=="50k",]
d_70_ind<-data_ind[data_ind$tree=="70k",]
d_BEAST_ind<-data_ind[data_ind$tree=="BEAST",]
d_20_unp_ind<-data_ind[data_ind$tree=="20k-unpart",]

#means
m_20_ind<-d_20_ind$mean
m_50_ind<-d_50_ind$mean
m_70_ind<-d_70_ind$mean
m_BEAST_ind<-d_BEAST_ind$mean
m_20_unp_ind<-d_20_unp_ind$mean


#HPD_size
r_20_ind<-d_20_ind$max.min
r_50_ind<-d_50_ind$max.min
r_70_ind<-d_70_ind$max.min
r_BEAST_ind<-d_BEAST_ind$max.min
r_20_unp_ind<-d_20_unp_ind$max.min

#############data_correlated#######

read.csv2("node_ages_corr.csv")->data_corr

data_corr$mean<-as.numeric(data_corr$mean)
data_corr$lower<-as.numeric(data_corr$lower)
data_corr$upper<-as.numeric(data_corr$upper)
data_corr$max.min<-as.numeric(data_corr$max.min)

#sep_dataset
d_20_corr<-data_corr[data_corr$tree=="20k",]
d_50_corr<-data_corr[data_corr$tree=="50k",]
d_70_corr<-data_corr[data_corr$tree=="70k",]
d_20_unp_corr<-data_corr[data_corr$tree=="20k-unpart",]

#means
m_20_corr<-d_20_corr$mean
m_50_corr<-d_50_corr$mean
m_70_corr<-d_70_corr$mean
m_20_unp_corr<-d_20_unp_corr$mean


#HPD_size
r_20_corr<-d_20_corr$max.min
r_50_corr<-d_50_corr$max.min
r_70_corr<-d_70_corr$max.min
r_20_unp_corr<-d_20_unp_corr$max.min

#bhatt_coeffs_ind
MEAN_20_50_ind<-bhatt.coeff(m_20_ind,m_50_ind)
MEAN_20_70_ind<-bhatt.coeff(m_20_ind,m_70_ind)
MEAN_20_BEAST_ind<-bhatt.coeff(m_20_ind,m_BEAST_ind)
MEAN_20_20_unp_ind<-bhatt.coeff(m_20_ind,m_20_unp_ind)
MEAN_50_70_ind<-bhatt.coeff(m_50_ind,m_70_ind)
MEAN_50_BEAST_ind<-bhatt.coeff(m_50_ind,m_BEAST_ind)
MEAN_50_20_unp_ind<-bhatt.coeff(m_50_ind,m_20_unp_ind)
MEAN_70_BEAST_ind<-bhatt.coeff(m_70_ind,m_BEAST_ind)
MEAN_70_20_unp_ind<-bhatt.coeff(m_70_ind,m_20_unp_ind)
MEAN_20_unp_BEAST_ind<-bhatt.coeff(m_20_unp_ind,m_BEAST_ind)


HPD_20_50_ind<-bhatt.coeff(r_20_ind,r_50_ind)
HPD_20_70_ind<-bhatt.coeff(r_20_ind,r_70_ind)
HPD_20_BEAST_ind<-bhatt.coeff(r_20_ind,r_BEAST_ind)
HPD_20_20_unp_ind<-bhatt.coeff(r_20_ind,r_20_unpart_ind)
HPD_50_70_ind<-bhatt.coeff(r_50_ind,r_70_ind)
HPD_50_BEAST_ind<-bhatt.coeff(r_50_ind,r_BEAST_ind)
HPD_50_20_unp_ind<-bhatt.coeff(r_50_ind,r_20_unpart_ind)
HPD_70_BEAST_ind<-bhatt.coeff(r_70_ind,r_BEAST_ind)
HPD_70_20_unp_ind<-bhatt.coeff(r_70_ind,r_20_unpart_ind)
HPD_20_unp_BEAST_ind<-bhatt.coeff(r_20_unpart_ind,r_BEAST_ind)

#bhatt_coeffs_corr

MEAN_20_50_corr<-bhatt.coeff(m_20_corr,m_50_corr)
MEAN_20_70_corr<-bhatt.coeff(m_20_corr,m_70_corr)
MEAN_20_20_unp_corr<-bhatt.coeff(m_20_corr,m_20_unpart_corr)
MEAN_50_70_corr<-bhatt.coeff(m_50_corr,m_70_corr)
MEAN_50_20_unp_corr<-bhatt.coeff(m_50_corr,m_20_unpart_corr)
MEAN_70_20_unp_corr<-bhatt.coeff(m_70_corr,m_20_unpart_corr)


HPD_20_50_corr<-bhatt.coeff(r_20_corr,r_50_corr)
HPD_20_70_corr<-bhatt.coeff(r_20_corr,r_70_corr)
HPD_20_20_unp_corr<-bhatt.coeff(r_20_corr,r_20_unpart_corr)
HPD_50_70_corr<-bhatt.coeff(r_50_corr,r_70_corr)
HPD_50_20_unp_corr<-bhatt.coeff(r_50_corr,r_20_unpart_corr)
HPD_70_20_unp_corr<-bhatt.coeff(r_70_corr,r_20_unpart_corr)

#bhatt_coeffs_indXcorr

MEAN_20_ind_20_corr<-bhatt.coeff(m_20_ind, m_20_corr)
MEAN_50_ind_50_corr<-bhatt.coeff(m_20_ind, m_20_corr)
MEAN_70_ind_70_corr<-bhatt.coeff(m_20_ind, m_20_corr)
MEAN_20_unp_ind_20_unp_corr<-bhatt.coeff(m_20_unp_ind, m_20_unpart_corr)
MEAN_BEAST_20_corr<-bhatt.coeff(m_BEAST_ind, m_20_corr)
MEAN_BEAST_50_corr<-bhatt.coeff(m_BEAST_ind, m_20_corr)
MEAN_BEAST_70_corr<-bhatt.coeff(m_BEAST_ind, m_20_corr)
MEAN_BEAST_20_unp_corr<-bhatt.coeff(m_BEAST_ind, m_20_unpart_corr)

HPD_20_ind_20_corr<-bhatt.coeff(r_20_ind, r_20_corr)
HPD_50_ind_50_corr<-bhatt.coeff(r_20_ind, r_20_corr)
HPD_70_ind_70_corr<-bhatt.coeff(r_20_ind, r_20_corr)
HPD_20_unp_ind_20_unp_corr<-bhatt.coeff(r_20_unp_ind, r_20_unpart_corr)
HPD_BEAST_20_corr<-bhatt.coeff(r_BEAST_ind, r_20_corr)
HPD_BEAST_50_corr<-bhatt.coeff(r_BEAST_ind, r_20_corr)
HPD_BEAST_70_corr<-bhatt.coeff(r_BEAST_ind, r_20_corr)
HPD_BEAST_20_unp_corr<-bhatt.coeff(r_BEAST_ind, r_20_unpart_corr)

#summarie_ind
Dataset_ind<-c("20_ind_50_ind", "20_ind_70_ind", "20_ind_BEAST", "20_ind_20_unp_ind", "50_ind_70_ind", "50_ind_BEAST",
               "50_ind_20_unp_ind", "70_ind_BEAST", "70_ind_20_unp_ind", "20_unp_ind_BEAST","20_corr_50_corr", 
               "20_corr_70_corr", "20_corr_20_unp_corr", "50_corr_70_corr", "50_corr_20_unp_corr", 
               "70_corr_20_unp_corr","20_ind_20_corr", "50_ind_50_corr","70_ind_70_corr","20_unp_ind_20_unp_corr", 
               "BEAST_20_corr","BEAST_50_corr","BEAST_70_corr","BEAST_20_unp_corr")
Mean_ind<-c(MEAN_20_50_ind, MEAN_20_70_ind, MEAN_20_BEAST_ind, MEAN_20_20_unp_ind, MEAN_50_70_ind, MEAN_50_BEAST_ind, 
            MEAN_50_20_unp_ind, MEAN_70_BEAST_ind, MEAN_70_20_unp_ind, MEAN_20_unp_BEAST_ind,MEAN_20_50_corr, 
            MEAN_20_70_corr, MEAN_20_20_unp_corr, MEAN_50_70_corr, MEAN_50_20_unp_corr, MEAN_70_20_unp_corr, 
            MEAN_20_ind_20_corr,MEAN_50_ind_50_corr,MEAN_70_ind_70_corr,MEAN_20_unp_ind_20_unp_corr, 
            MEAN_BEAST_20_corr, MEAN_BEAST_50_corr, MEAN_BEAST_70_corr, MEAN_BEAST_20_unp_corr)
HPD_size_ind<-c(HPD_20_50_ind,HPD_20_70_ind,HPD_20_BEAST_ind, HPD_20_20_unp_ind, HPD_50_70_ind, HPD_50_BEAST_ind, 
                HPD_50_20_unp_ind, HPD_70_BEAST_ind, HPD_70_20_unp_ind, HPD_20_unp_BEAST_ind, HPD_20_50_corr, 
                HPD_20_70_corr, HPD_20_20_unp_corr, HPD_50_70_corr, HPD_50_20_unp_corr, HPD_70_20_unp_corr, 
                HPD_20_ind_20_corr,HPD_50_ind_50_corr,HPD_70_ind_70_corr,HPD_20_unp_ind_20_unp_corr, 
                HPD_BEAST_20_corr, HPD_BEAST_50_corr, HPD_BEAST_70_corr, HPD_BEAST_20_unp_corr)

summary<-data.frame(Dataset_ind,Mean_ind,HPD_size_ind)
summary


write.csv(summary,"Bhattacharyya_coefficients.csv")
