if (!any(rownames(installed.packages()) == "MCMCtreeR")) install.packages("MCMCtreeR")
#devtools::install_github("kassambara/ggpubr")
#devtools::install_github("ropensci/tracerer")
#devtools::install_github("GuangchuangYu/treeio")
#install.packages("ggplot2")
#devtools::install_github("santiagosnchez/rBt")
#devtools::install_github("heibl/ips")
#install.packages("ips")
#install.packages("dplyr")
#install.packages("remotes")
#remotes::install_github("fmichonneau/phyloch")
#install.packages("gridExtra")
#install.packages("cowplot")
#install.packages("dplyr")

library(cowplot)
library(phyloch)
library(dplyr)
library(ips)
library(phytools)
library(ape)
library(rBt)
library(ggplot2)
library(MCMCtreeR, quietly = TRUE, warn.conflicts = FALSE)
library(tracerer)
library(ggtree)
library(treeio)
library(gridExtra)
library(ggpubr)
library(phylotools)

####plot tree node numbers###

ind_70k_t <- readMCMCtree("./70k/ind/mcmc_1/2/70k_ind_FigTree.tre")
ind_70k_t$apePhy$tip.label
plot(ind_70k_t$apePhy, cex=0.5)
nodelabels(cex=0.5, frame = "none",adj=c(1.1,-0.4))

novos_nomes<-as.data.frame(read.table("./Novos nomes-nooutgroups.txt",header = TRUE))
novos_nomes
tree<-sub.taxa.label(ind_70k_t$apePhy, novos_nomes)
tree$tip.label

pdf("tree.pdf", width = 10, height = 20)
plot(tree, cex=0.5, no.margins=TRUE)
nodelabels(cex=0.5, frame = "none",adj=c(1.1,-0.4))
dev.off()


##########independent rates###########

node <- list(seq(151,299))
node


ind_20k <- readMCMCtree("./20k/ind/mcmc_1/20k_ind_FigTree.tre")
ind_20k<-as.data.frame(ind_20k$nodeAges*100,)
ind_20k_1 <- list(rep("ind_20k",149))
ind_20k<-cbind(ind_20k, new_col=ind_20k_1)
names(ind_20k)[4]<-"Clock_Dataset"
ind_20k<-cbind(ind_20k, new_col=node)
names(ind_20k)[5]<-"node"

ind_50k <- readMCMCtree("./50k/ind/mcmc_1/50k_ind_FigTree.tre")
ind_50k<-as.data.frame(ind_50k$nodeAges*100)
ind_50k_1 <- list(rep("ind_50k",149))
ind_50k<-cbind(ind_50k, new_col=ind_50k_1)
names(ind_50k)[4]<-"Clock_Dataset"
ind_50k<-cbind(ind_50k, new_col=node)
names(ind_50k)[5]<-"node"

ind_70k <- readMCMCtree("./70k/ind/mcmc_1/2/70k_ind_FigTree.tre")
ind_70k<-as.data.frame(ind_70k$nodeAges*100)
ind_70k_1 <- list(rep("ind_70k",149))
ind_70k<-cbind(ind_70k, new_col=ind_70k_1)
names(ind_70k)[4]<-"Clock_Dataset"
ind_70k<-cbind(ind_70k, new_col=node)
names(ind_70k)[5]<-"node"

ind_20k_unpart<-readMCMCtree("./unpartitioned-20k/ind/mcmc_1/unp_20k_ind_FigTree.tre")
ind_20k_unpart<-as.data.frame(ind_20k_unpart$nodeAges*100)
ind_20k_unpart_1 <- list(rep("ind_20k_unpart",149))
ind_20k_unpart<-cbind(ind_20k_unpart, new_col=ind_20k_unpart_1)
names(ind_20k_unpart)[4]<-"Clock_Dataset"
ind_20k_unpart<-cbind(ind_20k_unpart, new_col=node)
names(ind_20k_unpart)[5]<-"node"

ind_prior <-readMCMCtree("./prior/ind/20k_ind_prior_FigTree.tre")
ind_prior<-as.data.frame(ind_prior$nodeAges*100)
ind_prior_1 <- list(rep("ind_prior",149))
ind_prior<-cbind(ind_prior, new_col=ind_prior_1)
names(ind_prior)[4]<-"Clock_Dataset"
ind_prior<-cbind(ind_prior, new_col=node)
names(ind_prior)[5]<-"node"

###Correlated rates########

corr_20k <- readMCMCtree("./20k/corr/mcmc_1/20k-corr-FigTree.tre")
corr_20k<-as.data.frame(corr_20k$nodeAges*100)
corr_20k_1 <- list(rep("corr_20k",149))
corr_20k<-cbind(corr_20k, new_col=corr_20k_1)
names(corr_20k)[4]<-"Clock_Dataset"
corr_20k<-cbind(corr_20k, new_col=node)
names(corr_20k)[5]<-"node"

corr_50k <- readMCMCtree("./50k/corr/mcmc_1/combined/50k_corr_FigTree.tre")
corr_50k<-as.data.frame(corr_50k$nodeAges*100)
corr_50k_1 <- list(rep("corr_50k",149))
corr_50k<-cbind(corr_50k, new_col=corr_50k_1)
names(corr_50k)[4]<-"Clock_Dataset"
corr_50k<-cbind(corr_50k, new_col=node)
names(corr_50k)[5]<-"node"

corr_70k <- readMCMCtree("./70k/corr/combined/70k_corr_FigTree.tre")
corr_70k<-as.data.frame(corr_70k$nodeAges*100)
corr_70k_1 <- list(rep("corr_70k",149))
corr_70k<-cbind(corr_70k, new_col=corr_70k_1)
names(corr_70k)[4]<-"Clock_Dataset"
corr_70k<-cbind(corr_70k, new_col=node)
names(corr_70k)[5]<-"node"

corr_20k_unpart<-readMCMCtree("./unpartitioned-20k/corr/mcmc_1/unp_20k_corr_FigTree.tre")
corr_20k_unpart<-as.data.frame(corr_20k_unpart$nodeAges*100)
corr_20k_unpart_1 <- list(rep("corr_20k_unpart",149))
corr_20k_unpart<-cbind(corr_20k_unpart, new_col=corr_20k_unpart_1)
names(corr_20k_unpart)[4]<-"Clock_Dataset"
corr_20k_unpart<-cbind(corr_20k_unpart, new_col=node)
names(corr_20k_unpart)[5]<-"node"

corr_prior <-readMCMCtree("./prior/corr/20k_corr_prior_FigTree.tre")
corr_prior<-as.data.frame(corr_prior$nodeAges*100)
corr_prior_1 <- list(rep("corr_prior",149))
corr_prior<-cbind(corr_prior, new_col=corr_prior_1)
names(corr_prior)[4]<-"Clock_Dataset"
corr_prior<-cbind(corr_prior, new_col=node)
names(corr_prior)[5]<-"node"

####including BEASt tree####

#to read in the same order as MCMCtreeR, first reorder nodes in FigTree in crescent order, them export as an annotated nexus####
treeio::read.beast("../../BEAST_nodeDating/Final-tree-combinedRuns-nodesOrdered.tre")->beast_tree
beast_tree@data->data

node<-data$node
mean<-round(data$height,2)
hpd<-data$height_0.95_HPD
min_max<-as.data.frame(matrix(nrow=length(hpd),ncol=2))
colnames(min_max)<-c("95%_lower","95%_upper")
for (i in 1:length(hpd))
{
  min_max[i,1]<-round(hpd[[i]][1],2)
  min_max[i,2]<-round(hpd[[i]][2],2)
}

join<-cbind(node,mean,min_max)
join_2<-join[join$mean!=0,]
BEAST<-join_2[order(join_2$node),]
row.names(BEAST)<-NULL

BEAST_1 <- list(rep("BEAST",149))
BEAST<-cbind(BEAST, new_col=BEAST_1)
names(BEAST)[5]<-"Clock_Dataset"

############################################
################combining data###############

ind_all<-rbind(ind_20k, ind_50k, ind_70k, ind_20k_unpart, BEAST)
ind_all$node<-as.character(ind_all$node)
corr_all<-rbind(corr_20k, corr_50k, corr_70k, corr_20k_unpart)
corr_all$node<-as.character(corr_all$node)
selected_rows<-c(151,152,153,154,158,229,231,232,246,254,267,268,270,284,294)
ind_sel<-filter(ind_all, node %in% selected_rows)
corr_sel<-filter(corr_all, node %in% selected_rows)
ind_sel
corr_sel

new_row_names<-as.character(c("01","02","05*","11","15","10","04","09","14","08","03","07","13","12*","06"))

ind_sel<-cbind(ind_sel, new_col=new_row_names)
ind_sel<-cbind(ind_sel, new_col=seq(1:15))
names(ind_sel)[6]<-"node_n"
names(ind_sel)[7]<-"node_order"
ind_sel <- as_tibble(ind_sel)
ind_sel<-ind_sel %>% arrange(node_order)

corr_sel<-cbind(corr_sel, new_col=new_row_names)
corr_sel<-cbind(corr_sel, new_col=seq(1:15))
names(corr_sel)[6]<-"node_n"
names(corr_sel)[7]<-"node_order"
corr_sel <- as_tibble(corr_sel)
corr_sel<-corr_sel %>% arrange(node_order)
corr_sel
####################################
##################Plots############

#####selected nodes############

plot_ind<-ggplot(ind_sel, aes(x = node_n, y=mean)) +
                geom_errorbar(aes(ymin = `95%_lower`, ymax = `95%_upper`, color = Clock_Dataset),
                              position = position_dodge(0.7), width = 0.03) +
                geom_point(aes(color = Clock_Dataset), position = position_dodge(0.7), size=0.8) +
                labs(title = "Independent rates",y = "Mya", x = "Node") +
                scale_y_continuous(breaks=c(10,20,30,40,50,60,70,80,90), limits = c(0,90)) +
                theme(plot.title = element_text(hjust = 0.5),legend.title = element_text(size = 10), 
                      legend.text = element_text(size = 7)) +
                scale_color_manual(values = c("ind_20k"="#F8766D", "ind_50k"='#BB9D00',"ind_70k"='#00B81F',
                                "ind_20k_unpart"='#00C0B8',"BEAST"='#00A5FF')) +
               theme_minimal_hgrid(12)
                     
plot_corr<-ggplot(corr_sel, aes(x = node_n, y=mean)) +
           geom_errorbar(aes(ymin = `95%_lower`, ymax = `95%_upper`, color = Clock_Dataset),
                        position = position_dodge(0.7), width = 0.03) +
            geom_point(aes(color = Clock_Dataset), position = position_dodge(0.7), size=0.8) +
            labs(title = "Correlated rates",x = "Node") +
            scale_y_continuous(breaks=c(10,20,30,40,50,60,70,80,90), limits = c(0,90)) +
            theme(axis.title.y = element_blank(),axis.ticks = element_blank(), axis.text.y = element_blank()) +
            theme(plot.title = element_text(hjust = 0.5)) +
            scale_color_manual(values = c("corr_20k"="#F8766D", "corr_50k"='#BB9D00',"corr_70k"='#00B81F',
                                "corr_20k_unpart"='#00C0B8')) +
            theme_minimal_hgrid(12)

legend <- get_legend(plot_ind)
plot_ind <- plot_ind + theme(legend.position="none", plot.title = element_text(hjust = 0.5), 
                             axis.text.x = element_text(size = 8), axis.text.y = element_text(size = 9),
                             axis.title.x = element_text(size = 11, face = "bold"),
                             axis.title.y = element_text(size = 11, face = "bold"))

plot_corr <- plot_corr + theme(legend.position="none",axis.title.y = element_blank(),
                               axis.ticks.y = element_blank(), axis.text.y = element_blank(),
                               plot.title = element_text(hjust = 0.5), axis.text.x = element_text(size = 8),
                               axis.title.x = element_text(size = 11, face = "bold"))

ggdraw(plot_grid(plot_ind, plot_corr,legend, ncol=3, nrow = 1, rel_widths = c(1,0.93,0.3)))
ggsave2(filename = "nodes_selected.pdf", device = "pdf", width = 29.7, height = 21, units = "cm")

plot(plot_ind)
plot(plot_corr)


#########all nodes############

plot_ind<-ggplot(ind_all, aes(x = node, y=mean)) +
  geom_errorbar(aes(ymin = `95%_lower`, ymax = `95%_upper`, color = Clock_Dataset),
                position = position_dodge(0.8), width = 0.01) +
  geom_point(aes(color = Clock_Dataset), position = position_dodge(0.8), size=0.8) +
  
  labs(title = "Independent rates",y = "Mya", x = "Node") +
  
  scale_y_continuous(breaks=c(10,20,30,40,50,60,70,80,90), limits = c(0,90)) +
  
  theme(plot.title = element_text(hjust = 0.5),panel.grid.minor.x = element_line(colour = "grey50"),
        axis.text.x = element_text(size = (2))) +
  
  scale_color_manual(values = c("ind_20k"="#F8766D", "ind_50k"='#BB9D00',"ind_70k"='#00B81F',
                                "ind_20k_unpart"='#00C0B8',"BEAST"='#00A5FF')) +
  theme_minimal_grid(12,rel_small = 0.5)

plot_corr<-ggplot(corr_all, aes(x = node, y=mean)) +
  geom_errorbar(aes(ymin = `95%_lower`, ymax = `95%_upper`, color = Clock_Dataset),
                position = position_dodge(0.8), width = 0.03) +
  geom_point(aes(color = Clock_Dataset), position = position_dodge(0.8), size=1) +
  
  labs(title = "Correlated rates",y = "Mya", x = "Node") +
  
  scale_y_continuous(breaks=c(10,20,30,40,50,60,70,80,90), limits = c(0,90)) +
  
  theme(plot.title = element_text(hjust = 0.5),panel.grid.minor.x = element_line(colour = "grey50"),
        axis.text.x = element_text(size = (2))) +
  
  scale_color_manual(values = c("corr_20k"="#F8766D", "corr_50k"='#BB9D00',"corr_70k"='#00B81F',
                                "corr_20k_unpart"='#00C0B8')) +
  theme_minimal_grid(12,rel_small = 0.5)

multi.page <- ggarrange(plot_ind,plot_corr, nrow=1, ncol=1) # for one plot per page
multi.page[[1]] # for seeing the first plot
ggexport(multi.page, filename="nodes_all_grid.pdf",res = 300, width = 26, height = 13.4)
plot(plot_corr)
plot(plot_ind)
