library(ggtree)
library(ggtreeExtra)
library(ggtree)
library(treeio)
library(tidytree)
library(ggstar)
library(ggplot2)
library(ggnewscale)
library(phylotools)


#read tree
tree<-read.tree("./tree.nwk")
tree$tip.label

#new names
novos_nomes<-as.data.frame(read.table("./Novos nomes-nooutgroups.txt",header = TRUE))
novos_nomes
tree<-sub.taxa.label(tree, novos_nomes)
tree$tip.label
write.tree(tree, "tree_renamed.tre")

#read area file
areas_file<-as.data.frame(read.delim("./R_areas.txt", sep="\t",stringsAsFactors = F))

areas_file

# basic plot
ggtree <- ggtree(tree, layout="fan",size=0.2, open.angle=5) +
    geom_tiplab(size=1.5, offset=3.4)+ geom_rootedge(rootedge = 1)


# add heatmap

p10<-gheatmap(ggtree, areas_file, offset=0, width=0.05,font.size=1, color="black",colnames=FALSE) +
    scale_fill_manual(breaks=c("S_South_America", "N_South_America","North_America","Old_World"), 
                      values=c("blue","green","yellow","red"), guide=guide_legend(keywidth=0.5, keyheight=0.5, order=6)) +
theme(legend.position=c(0.5, 0.4), # the position of legend.
    legend.background=element_rect(fill=NA), # the background of legend.
    legend.title=element_text(size=9), # the title size of legend.
    legend.text=element_text(size=8), # the text size of legend.
    legend.spacing.y = unit(0.02, "cm")  # the distance of legends (y orientation).
  )
# plot
plot(p10)


pdf("tree_states_cor-re.pdf", width = 8.27, height = 11.69)
plot(p10)
dev.off()

